﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace LindenmayerTool
{
    class ScoExporter
    {

        // Combine all the SoundObjects / Audio Events.
        String GenerateScoFile(LSystem lsys)
        {
            StringBuilder sb = new StringBuilder();

            foreach (SoundObject so in ((LSystem_Musical)(LSystem.I())).Score)
                sb.Append ( so.ToScoreEvent() );

            return sb.ToString();
        }

        // Merge the score prefix and our generated score
        // Put everything in the output file.
        public void Export(LSystem lsys, String filename)
        {
            lsys.Do(lsys.GetFinalItteration(false));
            
            var scoString = "";

            if (File.Exists(MusicMenu.CS_Sco_Prefix_File))
                scoString += File.ReadAllText(MusicMenu.CS_Sco_Prefix_File);

            scoString += GenerateScoFile(lsys);

            String path = Path.GetDirectoryName(filename);
            if (!Directory.Exists(path))
                Directory.CreateDirectory(path);

            File.WriteAllText(filename, scoString);
        }

    }
}
