﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LindenmayerTool
{
    public class SoundObject
    {
        public int Instrument; // Instrument number (1..n)
        public float StartTime;// Event time from start (in ms)
        public float Duration; // Event duration (in ms)
        public float Pitch;    // Pitch (in midi number?)
        public float Volume;   // Volume
        public float ParamC1;  // Customizable param
        public float ParamC2;  // Customizable param
        public float ParamC3;  // Customizable param

        public SoundObject() { }
        public SoundObject(SoundObject s)
        {
            Instrument = s.Instrument;
            StartTime  = s.StartTime;
            Duration   = s.Duration;
            Pitch      = s.Pitch;
            Volume     = s.Volume;
            ParamC1    = s.ParamC1;
            ParamC2    = s.ParamC2;
            ParamC3    = s.ParamC3;
        }

        public String ToScoreEvent()
        {
            String e = "";
            e += "i" + (Instrument+1) + "\t";
            e += (StartTime/1000) + "\t";
            e += (Duration/1000) + "\t";
            e += Pitch + "\t";
            e += Volume + "\t";
            e += ParamC1 + "\t";
            e += ParamC2 + "\t";
            e += ParamC3 + "\t";
            e += "\r\n";
            return e;
        }
    }
}
